=begin

    Copyright The Resistance (C) 1995-2011

    Author: blass
    blass[at]sdf.lonestar.org

    Badass 0.1 alpha

    This file is part of Badass.

    Badass is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Badass is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Badass.  If not, see <http://www.gnu.org/licenses/>.

=end

module Racket
  module L2
    # 802.3 Ethernet.  Should always be followed by an LLC header
    class EightOTwoDotThree < RacketPart
      # Destination MAC address
      hex_octets :dst_mac, 48
      # Source MAC address
      hex_octets :src_mac, 48
      # Length of the payload 
      unsigned :length, 16
      # Payload
      rest :payload
      
      # Fix this layer up prior to sending.  For 802.3, just adjusts +length+
      def fix!
        self.length = self.payload.length
      end
    end
  end
end
# vim: set ts=2 et sw=2:
