=begin

    Copyright The Resistance (C) 1995-2011

    Author: blass
    blass[at]sdf.lonestar.org

    Badass 0.1 alpha

    This file is part of Badass.

    Badass is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Badass is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Badass.  If not, see <http://www.gnu.org/licenses/>.

=end

module Racket
  module Misc
    # Simple ordered hash. 
    #
    # XXX: todo -- add a method for moving/shifting
    # members around
    class OrderedHash < Hash
      def initialize
        @keys = []
      end
      
      def []=(key, val)
        @keys << key unless (self[key])
        super
      end
      
      def delete(key)
        @keys.delete(key)
        super
      end
      
      def each
        @keys.each { |k| yield k, self[k] }
      end
      
      def each_key
        @keys.each { |k| yield k }
      end
      
      def each_value
        @keys.each { |k| yield self[k] }
      end
    end
  end
end
# vim: set ts=2 et sw=2:
